﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace ConsoleApplication1
{
    /**
     * Estrutura da ficha
     * 
     */
    public struct Ficha
    {
        public string nome;
        public int idade;
        public double altura;
        public double peso;
    }

    /**
     * 
     * 
     */
    class ControleDeIMC
    {
        // número atual de registros
        public static int registros = 0;

        // número máximo de registros
        public static int maxRegistros = 10;

        /**
         * gravarArquivosFichas
         * 
         * Grava em um arquivo texto as fichas cadastradas
         * 
         * A estrutura do arquivo é:
         * 
         * 1ª linha: número de registros
         * 2ª linha: nome1
         * 3ª linha: idade1
         * 4ª linha: peso1
         * 5ª linha: altura1
         * 2ª linha: nome2
         * 3ª linha: idade2
         * 4ª linha: peso2
         * 5ª linha: altura2
         * 
         * Parâmetros:
         *   @param fichas Ficha[] Array contendo as fichas preenchidas que será gravadas no arquivo
         * 
         * Retorno:
         *   Retorna void
         */
        static public void gravarArquivosFichas(Ficha[] fichas)
        {

            // insira aqui o código do método
        }

        /**
         * listarFichas
         * 
         * Exibe no console a relação de todas as fichas cadastradas
         *
         * Parâmetros:
         *   @param fichas Ficha[] Array contendo as fichas preenchidas que serão exibidas no console
         * 
         * Retorno:
         *   void
         *   
         */
        static public void listarFichas(Ficha[] fichas)
        {
            // insira aqui o código do método
        }

        /**
         * Exibe no console a relação de todas as fichas cadastradas juntamente
         * com o IMC calculado para cada ficha.
         * O valor do IMC deverá ser apresentado com duas casas
         * decimais
         *
         * Parâmetros:
         *   @param fichas Ficha[] Array contendo as fichas preenchidas que serão exibidas no console
         * 
         * Retorno:
         *   void
         * 
         * Parâmetros:
         *   @param fichas Ficha[] Array onde a nova ficha será inserida 
         * 
         * Retorno:
         *   void
         *
         */
        static public void listarFichasIMC(Ficha[] fichas)
        {
            // insira aqui o código do método
        }


        /**
         * inserirRegistro
         * 
         * Insere um novo registro (ficha) no
         * array, caso ainda haja espaço.
         * Exibe mensagem de erro no caso de não haver mais
         * espaço para uma nova ficha
         * 
         */
        static public void inserirRegistro(Ficha[] ficha)
        {
            // insira aqui o código do método
        }

        /**
         * lerAquivoFichas
         * 
         * Lê o arquivo e insere todas as fichas em um array
         * 
         */
        static public void lerArquivoFichas(ref Ficha[] fichas)
        {
            Console.WriteLine("lerArquivoFichas");
            // insira aqui o código do método
           
        }

        /**
         * Exibe uma mensagem e lê uma
         * string do teclado
         * 
         * Parâmetros:
         * @param msg string mensagem exibida
         * 
         * Retorno:
         * @return string A string lida
         * 
         */
        static public String LeString(String msg)
        {
            Console.Write("{0}", msg);
            String s = Console.ReadLine();
            return s;
        }


        /**
         * LerFicha
         * 
         * Lê a ficha de informações de uma pessoa.
         * As informações de nome, idade, peso,
         * altura será fornecidas via teclado
         * 
         * Parâmetros:
         *   nenhum
         *   
         * Retorna:
         *   @return uma Ficha com as informações preenchidas
         * 
         */
        static public Ficha LerFicha()
        {

             // cria uma nova ficha
            Ficha ficha;

            ficha.nome = "";
            ficha.idade = 0;
            ficha.peso = 0;
            ficha.altura = 0;

            // insira aqui o código do método

            // retorna a ficha da pessoa
            return ficha;

        }

        /**
         * imc
         * 
         * Calcula o Indice de Massa Corporea de uma pessoa
         * 
         * imc = (peso)/(altura*altura)
         * 
         */
        static public double imc(Ficha ficha)
        {
            double valorIMC = 0.0;

            // insira o código aqui

            return valorIMC;
        }

        /**
         * ExibeFicha
         * 
         * Exibe no console a ficha de um pessoa
         * no formato:
         * Nome: XXXX
         * Idade: XX
         * Peso: XX
         * Altura: XX
         * 
         * Parâmetros:
         *   @param ficha Ficha com os dados da pessoa
         * 
         * Retorno:
         *   Retorna void
         */
        static public void ExibeFicha(Ficha ficha)
        {
            // insira o código aqui
        }

        /**
         * Menu
         * 
         * Exibe e seleciona uma opcao do menu
         * 
         * Retorna a opção selecionada do menu
         * 
         */
        static public int Menu()
        {
            string opcao; // opcão selecionada

            int op=0;

            bool valida = false;

            // repete enquanto a condição não for válida
            do
            {
                
                Console.WriteLine("Menu");
                Console.WriteLine("1-Inserir um registro");
                Console.WriteLine("2-Gravar os registros em um arquivo");
                Console.WriteLine("3-Ler os registros de um arquivo");
                Console.WriteLine("4-Listar todos os registros");
                Console.WriteLine("5-Listar o IMC de todos");
                Console.WriteLine();

                opcao = LeString("Entre com a opcao desejada: ");
                
                if (opcao.Length == 0)
                {
                    opcao = "0";
                }

                op = int.Parse(opcao);

                if ((op < 0) || (op > 5))
                {
                    // opção inválida
                    Console.WriteLine("Opcao {0} e invalida", op);
                    valida = false;
                }
                else
                {
                    // opção válida
                    valida = true;
                }

                Console.WriteLine();

            } while (!valida);

            return op;

        }


        /**
         * Programa principal
         *
         */
        static void Main(string[] args)
        {
          
            // Cria um array que conterá fichas
            Ficha[] fichas = new Ficha[maxRegistros];

            int opcao = 0;

            do
            {

                // exibe e obtem uma opção do Menu
                opcao = Menu();

                switch (opcao)
                {
                    case 0:
                        // sai da aplicação
                        break;
                    case 1:
                        // Insere uma nova ficha
                        inserirRegistro(fichas);
                        break;
                    case 2:
                        // grava em arquivo todas as fichas
                        gravarArquivosFichas(fichas);
                        break;
                    case 3:
                        // lê de um arquivo todas as fichas
                        lerArquivoFichas(ref fichas);
                        break;
                    case 4:
                        // Exibe todas as fichas preenchidas
                        listarFichas(fichas);
                        break;
                    case 5:
                        // Exibe todas as fichas e o IMC calculado
                        // para cada ficha
                        listarFichasIMC(fichas);
                        break;
                }

            } while (opcao != 0);

        }
    }
}
